package de.nwsnet.homework.LocalHostInfo;

/*
 * Copyright (c) 2003, 2003 Jochen Kupperschmidt <jochen@kupperschmidt.de>
 * Released under the terms of the GNU General Public License
 *    _                               _
 *   | |_ ___ _____ ___ _ _ _ ___ ___| |_
 *   |   | . |     | ._| | | | . |  _| . /
 *   |_|_|___|_|_|_|___|_____|___|_| |_|_\
 *     http://homework.nwsnet.de/
 */

import java.awt.BorderLayout;
import java.awt.Dimension;
import java.awt.Toolkit;
import java.net.InetAddress;
import java.net.URL;
import java.net.UnknownHostException;

import javax.swing.ImageIcon;
import javax.swing.JFrame;
import javax.swing.JOptionPane;
import javax.swing.JPanel;

/**
 * The main swing application that includes the other panels.
 *
 * @author  <a href="mailto:jochen@kupperschmidt.de">Jochen Kupperschmidt</a>
 * @version 28-Mar-2003
 */
public class Frontend extends JFrame {

	public Frontend() {
		// create panels
		FieldsPanel fieldsPanel = new FieldsPanel();
		InterfacesPanel interfacesPanel = new InterfacesPanel(this);

		try {
			// get local host information
            InetAddress localhost = InetAddress.getLocalHost();
			fieldsPanel.showHostInfo(localhost);
        } catch (UnknownHostException e) {
			JOptionPane.showMessageDialog(this, "Error: " + e.getMessage());
		}

		// add panels to content pane
		JPanel contentPane = new JPanel(new BorderLayout());
		contentPane.add(fieldsPanel, BorderLayout.NORTH);
		contentPane.add(interfacesPanel, BorderLayout.CENTER);
        setContentPane(contentPane);

		// set frame properties
        setTitle("LocalHostInfo");
        setIconImage(getNicIcon().getImage());
        setDefaultCloseOperation(JFrame.EXIT_ON_CLOSE);
        pack();
		setLocationRelativeTo(null);
		setSize(new Dimension(360, 280));
	}

	protected ImageIcon getNicIcon() {
		String iconfile = "icon_nic.png";
		try {
			URL url = getClass().getResource(iconfile);
			if (url == null) {
				throw new NullPointerException("Bad URL");
			}
			return new ImageIcon(Toolkit.getDefaultToolkit().getImage(url));
		} catch (NullPointerException e) {
            System.err.println(
                "Resources: could not load image '" + iconfile + "': "
                + e.getMessage());
			return null;
		}
	}

	// program starts here
	public static void main(String[] args) {
		new Frontend().setVisible(true);
	}
}
